class Kugel {

   protected PVector position;
   protected PVector geschwindigkeit;
   protected float radius;
   protected color farbe;

  Kugel(PVector p, float r, PVector v, color f) {
    position = p;
    geschwindigkeit = v;
    radius = r;
    farbe = f;
  }

  void setPos(PVector pos) { position = new PVector(pos.x,pos.y); }
  void setGeschw(PVector geschw) { geschwindigkeit = new PVector(geschw.x,geschw.y); }
  PVector getPos() { return position; }
  PVector getGeschw() { return geschwindigkeit; }


  void aktualiseren() { 
    position = position.add(geschwindigkeit);
    geschwindigkeit.x *= factor;
    geschwindigkeit.y *= factor;
  }
  
  void pruefeKollisionRand() {
    if (position.x >= width-radius) {
      position.x = width-radius;
      geschwindigkeit.x *= -1;      
   } else if (position.x <=radius) {
      position.x = radius;
      geschwindigkeit.x *= -1;
    } else if (position.y >= height-radius) {
      position.y = height-radius;
      geschwindigkeit.y *= -1;
    } else if (position.y <= radius) {
      position.y = radius;
      geschwindigkeit.y *= -1;
    }
  }
  
  void pruefeKollisionRechteck() {
    if ((position.x >= hindernis_xmin-radius) && (position.x <= hindernis_xmax+radius)) {
      // Kugel ist auf Breite des Hindernisses
      if ((geschwindigkeit.y > 0 ) && (position.y >= hindernis_ymin-radius) && (position.y <= hindernis_ymin)) {
         geschwindigkeit.y *= -1;
         position.y = hindernis_ymin-radius;
      } else if ((geschwindigkeit.y < 0 ) && (position.y >= hindernis_ymax) && (position.y <= hindernis_ymax+radius)) {
         geschwindigkeit.y *= -1;
         position.y = hindernis_ymax+radius;
        }
    } 
    if ((position.y >= hindernis_ymin-radius) && (position.y <= hindernis_ymax+radius)) {
     // Kugel ist auf Höhe des Hindernisses
      if ((geschwindigkeit.x > 0 ) && (position.x >= hindernis_xmin-radius) && (position.x <= hindernis_xmin)) {
         geschwindigkeit.x *= -1;
         position.x = hindernis_xmin-radius;
      } else if ((geschwindigkeit.x < 0 ) && (position.x >= hindernis_xmax) && (position.x <= hindernis_xmax+radius)) {
         geschwindigkeit.x *= -1;
         position.x = hindernis_xmax+radius;
        }
    }
  }
    
  void display() {  
    noStroke();
    fill(farbe);
    ellipse(position.x, position.y, radius*2, radius*2); 
  }
}