///////////////////////////////////////////////////////////////////
//billiard02 Kapitel Simulationen
/////////////////////////////////////////////////////////////////////
private ArrayList<Kugel> kugeln;

private int hindernis_xmin = 450;
private int hindernis_ymin = 200;
private int hindernis_xmax = 550;
private int hindernis_ymax = 300;
private float friction = 0.001;
private float factor = 1-friction;
private float ballGeschw = 15;

void setup() {
  size(1000, 500, P3D);//Mit dem Renderer P3D kann schneller gezeichnet werden
  kugeln = new ArrayList<Kugel>();
  kugeln.add(new Kugel(new PVector(70, height/2), 30, new PVector(0, 0), color(255)));

}

void mouseClicked() {
 
   kugeln.get(0).geschwindigkeit = new PVector(random(5,ballGeschw), random(5,ballGeschw)); 
}

void draw() {  
  background(0, 120, 0);  
  fill(255);
  rectMode(CORNERS);
  rect(hindernis_xmin, hindernis_ymin, hindernis_xmax, hindernis_ymax);

  for (Kugel b : kugeln) {
    b.aktualiseren();
    b.display();
    b.pruefeKollisionRand();
    b.pruefeKollisionRechteck();
  }
}

void keyPressed() { save("test.png"); }